
// by Raiden on Mar.26,2018 
// User can Quicker.a to communication with other AP

#ifndef QUICKER_H
#define QUICKER_H

#define LINPACAGENT_API extern

LINPACAGENT_API void UserShare_Init(void);

// public string variable for C to read/write
// iUserAddress : 1 ~ 1024
// iStatus: message pointer
// len: 1~256
// return 0: OK, -1: error, 1: busy
// ------------------------------------------------------------------------------
LINPACAGENT_API int UserSetReg_Str(unsigned short iUserAddress, char *iStatus, unsigned short len);
LINPACAGENT_API int UserGetReg_Str(unsigned short iUserAddress, char *iStatus, unsigned short len);
// ------------------------------------------------------------------------------


// chekc public string variable is busy or not
// iUserAddress : 1 ~ 1024
// return 1: busy , 0: not busy
LINPACAGENT_API unsigned char UserGetReg_Str_flag(unsigned short iUserAddress);
// ---------------------------------------------------------------------------------


// iUserAddress : 1 ~ 8192
// return 0: OK, other: Error 
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
LINPACAGENT_API unsigned char UserShare_Set_Coil(unsigned short iUserAddress, unsigned char iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Coil(unsigned short iUserAddress, unsigned char *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_Float(unsigned short iUserAddress, float iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Float(unsigned short iUserAddress, float *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_Double(unsigned short iUserAddress, double iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Double(unsigned short iUserAddress, double *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_Short(unsigned short iUserAddress, short iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Short(unsigned short iUserAddress, short *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_Long(unsigned short iUserAddress, long iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Long(unsigned short iUserAddress, long *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_Int64(unsigned short iUserAddress, long long iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Int64(unsigned short iUserAddress, long long *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_UInt64(unsigned short iUserAddress, unsigned long long iStatus);
LINPACAGENT_API unsigned char UserShare_Get_UInt64(unsigned short iUserAddress, unsigned long long *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_ULong(unsigned short iUserAddress, unsigned long iStatus);
LINPACAGENT_API unsigned char UserShare_Get_ULong(unsigned short iUserAddress, unsigned long *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_UShort(unsigned short iUserAddress, unsigned short iStatus);
LINPACAGENT_API unsigned char UserShare_Get_UShort(unsigned short iUserAddress, unsigned short *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_Char(unsigned short iUserAddress, char iStatus);
LINPACAGENT_API unsigned char UserShare_Get_Char(unsigned short iUserAddress, char *iStatus);
LINPACAGENT_API unsigned char UserShare_Set_UChar(unsigned short iUserAddress, unsigned char iStatus);
LINPACAGENT_API unsigned char UserShare_Get_UChar(unsigned short iUserAddress, unsigned char *iStatus);

// return version number
LINPACAGENT_API unsigned char UserShare_Get_Ver();
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#endif
